package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConfRestricaoPtovtaDAO;
import com.rjconsultores.ventaboletos.entidad.ConfRestricaoPtovta;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.ConfRestricaoPtovtaService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("confRestricaoPtovtaService")
public class ConfRestricaoPtovtaServiceImpl implements ConfRestricaoPtovtaService {

	@Autowired
	ConfRestricaoPtovtaDAO confRestricaoPtovtaDAO;
	@Autowired
	private PuntoVentaService puntoVentaService;

	@Override
	public List<ConfRestricaoPtovta> obtenerTodos() {
		return confRestricaoPtovtaDAO.obtenerTodos();
	}

	@Override
	public ConfRestricaoPtovta obtenerID(Integer id) {
		return confRestricaoPtovtaDAO.obtenerID(id);
	}

	@Override
	public ConfRestricaoPtovta obtenerPtovtaTodos() {

		ConfRestricaoPtovta entidad = new ConfRestricaoPtovta();

		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		PuntoVenta puntoVenta = puntoVentaService.obtenerID(-1);
		entidad.setPuntoVenta(puntoVenta);

		return entidad;
	}

	@Override
	@Transactional
	public ConfRestricaoPtovta suscribir(ConfRestricaoPtovta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoPtovtaDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public ConfRestricaoPtovta actualizacion(ConfRestricaoPtovta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoPtovtaDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(ConfRestricaoPtovta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		confRestricaoPtovtaDAO.actualizacion(entidad);
	}

}
